from wooly import *
from wooly.widgets import *
from wooly.resources import *

from cumin.main import CuminModule
from cumin.objecttask import *
from cumin.util import *

from submission import *
from pool import *
from test import *

strings = StringCatalog(__file__)

class Module(CuminModule):
    def __init__(self, app, name):
        super(Module, self).__init__(app, name)

        self.job_submit = JobSubmit(app)
        self.dag_job_submit = DagJobSubmit(app)
        self.vm_job_submit = VmJobSubmit(app)
    
    def add_module_for_submits(self, module):
        # Well, none of these are actually contained by
        # anything per se and they are linked to via TaskLink
        # objects from multiple places in grid and usergrid.
        # Allow module values to be added...

        for s in (self.job_submit,
                  self.dag_job_submit,
                  self.vm_job_submit):
            if not hasattr(s.form, "cumin_module"):
                s.form.cumin_module = []
            s.form.cumin_module.append(module)

    def init(self):
        super(Module, self).init()

        self.app.export_page.set_cumin_module_for_children(self.name)
        self.frame = PoolFrame(self.app, "grid")
        self.frame.cumin_module = self.name
        self.add_module_for_submits(self.name)
        self.app.main_page.add_to_view(self.frame)

    def init_test(self, test):
        GridTest("grid", test)
